Qore Programming Language Reference Manual: Qore::ObjectPairIterator Class Reference

Qore Programming Language Reference Manual 0.8.11

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Groups Pages
Public Member Functions | List of all members
Qore::ObjectPairIterator Class Reference

This class an iterator class for objects. More...

Inheritance diagram for Qore::ObjectPairIterator:
[legend]

## Public Member Functions
| constructor (object o)
| Creates the object iterator object. More...
| constructor ()
| Creates an empty object iterator object. More...
| copy ()
| Creates a copy of the ObjectPairIterator object, iterating the same object as the original and in the same position. More...
hash | getValue ()
| returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
Public Member Functions inherited from Qore::ObjectIterator
| constructor (object o)
| Creates the object iterator object. More...
| constructor ()
| Creates an empty object iterator object. More...
| copy ()
| Creates a copy of the ObjectIterator object, iterating the same object as the original and in the same position. More...
Public Member Functions inherited from Qore::HashIterator
| constructor (hash h)
| Creates the hash iterator object. More...
| constructor ()
| Creates an empty hash iterator object. More...
| copy ()
| Creates a copy of the HashIterator object, iterating the same object as the original and in the same position. More...
bool | empty ()
| returns True if the hash is empty; False if not More...
bool | first ()
| returns True if on the first element of the hash More...
string | getKey ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
any | getKeyValue ()
| returns the current value of the current has key being iterated or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
hash | getValuePair ()
| returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
bool | last ()
| returns True if on the last element of the hash More...
bool | next ()
| Moves the current position to the next element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the hash if the hash is not empty. More...
bool | prev ()
| Moves the current position to the previous element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the hash if the hash is not empty. More...
| reset ()
| Reset the iterator instance to its initial state. More...
bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not More...

## Detailed Description

This class an iterator class for objects.

Call ObjectPairIterator::next() to iterate through the object; do not use the iterator if ObjectPairIterator::next() returns False. A object can be iterated in reverse order by calling ObjectPairIterator::prev() instead of ObjectPairIterator::next()

Example: ObjectPairIterator basic usage
  class Class1 {
  public {
  int $.attr1;
  date $.attr2;
  }
  constructor() {
  $.attr1 = 1;
  $.attr2 = now();
  }
  }
  my Class1 $o();
  my ObjectPairIterator $it($o);
  while ($it.next()) {
  printf("iter: %n\n", $it.getValue());
  }
  iter: hash: (key : "attr1", value : 1)
  iter: hash: (key : "attr2", value : 2013-04-17 16:37:26 Wed +02:00 (CEST))

Note
  - In general, the ObjectPairIterator class is not designed to be accessed from multiple threads; it was created without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause an `ITERATOR-THREAD-ERROR` to be thrown.

See Also
  ObjectPairReverseIterator

## Member Function Documentation

Qore::ObjectPairIterator::constructor | ( | object | o | ) |

Creates the object iterator object.

Parameters

  o | the object to iterate

Example:
  my ObjectPairIterator $i($obj);

Qore::ObjectPairIterator::constructor | ( |  | ) |

Creates an empty object iterator object.

Example:
  my *object $obj = get_object_or_nothing();
  my ObjectPairIterator $i($obj);

Qore::ObjectPairIterator::copy | ( |  | ) |

Creates a copy of the ObjectPairIterator object, iterating the same object as the original and in the same position.

Example:
  my ObjectPairIterator $ni = $i.copy();

hash Qore::ObjectPairIterator::getValue | ( |  | ) |
| virtual

returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Returns
  a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid

Code Flags:
  RET_VALUE_ONLY

Example:
  map printf("%s: %y\n", $1.key, $1.value), $object.pairIterator();

Exceptions

  INVALID-ITERATOR | the iterator is not pointing at a valid element
  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Since
  Qore 0.8.6.2

Reimplemented from Qore::HashIterator.